models/Formulario.php
<?php

namespace app\models;

use Yii;
use yii\base\Model;

/**
 * LoginForm is the model behind the login form.
 *
 * @property User|null $user This property is read-only.
 *
 */

class Formulario extends Model
{
    public $nombre;
    public $apellidos;
    public $edad;
   
    public $peso;
    public $altura;
    public $valoresPoblacion=[
        "santander"=>'Santander',
        "potes"=>'Potes',
        "laredo"=>'Laredo'
    ];
  
    public function rules()
    {
        return [
            [['nombre','edad','peso','altura'],"required", "message"=>"El campo {attribute} no puede estar vacío"],
            ['edad','integer',"message"=>"El campo edad debe ser numérico"],
            ['apellidos','string','max'=>50,"tooLong"=>"Máximo 50 caracteres"],
            ['poblacion','in','range'=> array_keys($this->getValoresPoblacion())],
            ['altura','number','min'=>100,'max'=>250,"tooBig"=>"Debe ser menor de 250","tooSmall"=>"Debe ser mayor de 100"],
            [['nombre','edad','apellidos','peso','altura','peso'],"safe"], //carga masiva             
        ];
    }
    public function getValoresPoblacion(){
        return [
           "poblacion"=>$this->valoresPoblacion,
                ];
    }
    public function attributeLabels() {
      return[ 'nombre'=>'Nombre del trabajador',
              'apellidos'=>'Apellidos',
              'edad'=>'Edad del trabajador',
              'poblacion'=>'Población',
              'peso'=>'Peso',
              'altura'=>'Altura',
              
            ]  ;
        
    }
    
    public function getNombreCompleto(){
        return [$this->nombre." ".$this->apellidos];
    }
    public function getImc(){
        return[
            ($this->altura)/($this->peso)
        ];
    }
}

controllers/FormulariosController.php
<?php

namespace app\controllers;

use Yii;
use yii\filters\AccessControl;
use yii\web\Controller;
use yii\web\Response;
use yii\filters\VerbFilter;
use app\models\LoginForm;
use app\models\ContactForm;
use app\models\Formulario;

class FormulariosController extends Controller {

    public function actionPrueba() {

        return ($this->render("formulario"));
    }

    public function actionIndex() {
        $id = Yii::$app->request->post();
        if ($id) {
            $mensaje = $id;
        } else {
            return $this->redirect(["formularios/formu1"]);
        }
        return $this->render("index", [
                    "mensaje" => $mensaje,
        ]);
    }


    public function actionFormu1() {
        return $this->render("formulario");
    }

    public function actionResultados() {
        $id = Yii::$app->request->post();
        return $this->render("resultados", [
                    "id" => $id
        ]);
    }

    public function actionFormu2() {
        $model = new Formulario();
        $dato = Yii::$app->request->post();
        if ($dato) {
            $model->load(Yii::$app->request->post());
            return $this->render("index", [
                        "mensaje" => $model
            ]);
        }
    
        return $this->render("formulario1", [
                    "model" => $model,
        ]);
    }
    
    public function actionFormu3() {
        $model = new Formulario();
        $dato = Yii::$app->request->post();
        
        if ($dato) {
            $model->load(Yii::$app->request->post());
            //if($model->validate());
            if($model->validate()){
            return $this->render("index1", [
                        "mensaje" => $model,
                        "nombreCompleto"=>$model->getNombreCompleto(),
                        "imc"=>$model->getImc(),
                        "model"=>$model
            ]);
            }
        }
        
        return $this->render("formulario3", [
                    "model" => $model,
                   
        ]);
    }
    
    


}

views/formularios/formulario.php
<?php
use yii\helpers\html;
echo Html::beginForm(
        ['formularios/index'],
        'post'
        );
?>

    <div class='form-group'>
    <label>Nombre: </label><?= Html::input('text', 'nombre',NULL,['class'=>'form-control']) ?> 
    </div>
 
    <div class='form-group'>
    <label>Edad: </label><?= Html::input('number', 'edad',NULL,['class'=>'form-control']) ?>
    </div>
 <?= Html::submitButton('Enviar', ['class' => 'btn btn-primary']); ?>
  <?= Html::endForm(); ?>

views/formularios/formulario1.php
<?php
use yii\helpers\Html;
use yii\widgets\ActiveForm;

$form = ActiveForm::begin([
    'id' => 'login-form',
    'options' => ['class' => 'form-horizontal'],
]) ?>
    <?= $form->field($model, 'nombre'); ?>
    <?= $form->field($model, 'edad'); ?>

    <div class="form-group">
        <div class="col-lg-offset-1 col-lg-11">
            <?= Html::submitButton('Enviar', ['class' => 'btn btn-primary']) ?>
        </div>
    </div>
<?php ActiveForm::end() ?>

views/formularios/formulario3.php
<?php
use yii\helpers\Html;
use yii\widgets\ActiveForm;

$form = ActiveForm::begin([
    'id' => 'login-form',
    'options' => ['class' => 'form-horizontal'],
]) ;
//$var = [ 0 => 'Santander', 1 => 'Torrelavega',  2 => 'Potes'];
        
        ?>
    <?= $form->field($model, 'nombre'); ?>
    <?= $form->field($model, 'apellidos'); ?>
    <?= $form->field($model, 'poblacion')->dropDownList($model->getValoresPoblacion(), ['prompt' => 'Seleccione una población' ]); ?>
    <?= $form->field($model, 'peso'); ?>
    <?= $form->field($model, 'altura'); ?>




    <div class="form-group">
        <div class="col-lg-offset-1 col-lg-11">
            <?= Html::submitButton('Enviar', ['class' => 'btn btn-primary']) ?>
        </div>
    </div>
<?php ActiveForm::end() ?>

views/formularios/formulario_1.php
<?php
use yii\helpers\Html;
?>

<?= Html::beginForm(['/formularios/resultados',/* 'id' => $model->id*/], 'POST'); ?>
    <div><label>Nombre: </label><?= Html::input('text', 'nombre') ?></div>
    <div><label>Edad: </label><?= Html::input('number', 'edad') ?></div>
 
<div class="form-group">
   <?= Html::submitButton('Enviar', ['class' => 'btn btn-primary']); ?>
</div>
<?= Html::endForm(); ?>

views/formularios/index.php
<?php
var_dump($mensaje);
var_dump($nombreCompleto);
var_dump($imc);
    

views/formularios/index1.php
<?php 
use yii\widgets\DetailView;
?>
<?= DetailView::widget([
        'model' => $model,
        'attributes' => [
            
            'nombre',
            'apellidos',
            'altura',
            'peso',
            'poblacion',
            ['nombreCompleto'=>function($modelo){
                 return $model->getNombreCompleto();
            }],
            ['imc'=>function($modelo){
                 return $model->getImc();
            }]
        ],
    ]) ?>

views/formularios/resultados.php
<?php 
//var_dump($id);
?>
<div>Nombre:<?= $id["nombre"]?> </div>
<div>Apellido:<?= $id["edad"]?> </div>